/* PreferencesWindow.c generated by valac 0.56.1, the Vala compiler
 * generated from PreferencesWindow.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "deja.h"
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES_WINDOW (preferences_window_get_type ())
#define PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_WINDOW, PreferencesWindow))
#define PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_WINDOW, PreferencesWindowClass))
#define IS_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_WINDOW))
#define IS_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_WINDOW))
#define PREFERENCES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_WINDOW, PreferencesWindowClass))

typedef struct _PreferencesWindow PreferencesWindow;
typedef struct _PreferencesWindowClass PreferencesWindowClass;
typedef struct _PreferencesWindowPrivate PreferencesWindowPrivate;
enum  {
	PREFERENCES_WINDOW_0_PROPERTY,
	PREFERENCES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* preferences_window_properties[PREFERENCES_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PreferencesWindow {
	AdwPreferencesWindow parent_instance;
	PreferencesWindowPrivate * priv;
};

struct _PreferencesWindowClass {
	AdwPreferencesWindowClass parent_class;
};

struct _PreferencesWindowPrivate {
	GtkLabel* location_description;
	AdwPreferencesPage* labs_page;
};

static gint PreferencesWindow_private_offset;
static gpointer preferences_window_parent_class = NULL;

VALA_EXTERN GType preferences_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesWindow, g_object_unref)
static void preferences_window_update_location_description (PreferencesWindow* self);
VALA_EXTERN PreferencesWindow* preferences_window_new (void);
VALA_EXTERN PreferencesWindow* preferences_window_construct (GType object_type);
static GObject * preferences_window_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _preferences_window_update_location_description_deja_dup_backend_watcher_changed (DejaDupBackendWatcher* _sender,
                                                                                       gpointer self);
static void preferences_window_finalize (GObject * obj);
static GType preferences_window_get_type_once (void);

static inline gpointer
preferences_window_get_instance_private (PreferencesWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesWindow_private_offset);
}

static void
preferences_window_update_location_description (PreferencesWindow* self)
{
	DejaDupBackend* backend = NULL;
	DejaDupBackend* _tmp0_;
	GtkLabel* _tmp1_;
	DejaDupBackend* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = deja_dup_backend_get_default ();
	backend = _tmp0_;
	_tmp1_ = self->priv->location_description;
	_tmp2_ = backend;
	_tmp3_ = deja_dup_backend_get_location_pretty (_tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp1_, _tmp4_);
	_g_free0 (_tmp4_);
	if (deja_dup_in_demo_mode ()) {
		GtkLabel* _tmp5_;
		_tmp5_ = self->priv->location_description;
		gtk_label_set_label (_tmp5_, "hostname on Google Drive");
	}
	_g_object_unref0 (backend);
}

PreferencesWindow*
preferences_window_construct (GType object_type)
{
	PreferencesWindow * self = NULL;
	self = (PreferencesWindow*) g_object_new (object_type, NULL);
	return self;
}

PreferencesWindow*
preferences_window_new (void)
{
	return preferences_window_construct (TYPE_PREFERENCES_WINDOW);
}

static void
_preferences_window_update_location_description_deja_dup_backend_watcher_changed (DejaDupBackendWatcher* _sender,
                                                                                  gpointer self)
{
	preferences_window_update_location_description ((PreferencesWindow*) self);
}

static GObject *
preferences_window_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PreferencesWindow * self;
	DejaDupBackendWatcher* watcher = NULL;
	DejaDupBackendWatcher* _tmp0_;
	DejaDupBackendWatcher* _tmp1_;
	AdwPreferencesPage* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	parent_class = G_OBJECT_CLASS (preferences_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_WINDOW, PreferencesWindow);
	_tmp0_ = deja_dup_backend_watcher_get_instance ();
	watcher = _tmp0_;
	_tmp1_ = watcher;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _preferences_window_update_location_description_deja_dup_backend_watcher_changed, self, 0);
	preferences_window_update_location_description (self);
	_tmp2_ = self->priv->labs_page;
	_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		AdwPreferencesPage* _tmp5_;
		_tmp5_ = self->priv->labs_page;
		adw_preferences_window_remove ((AdwPreferencesWindow*) self, _tmp5_);
	}
	_g_object_unref0 (watcher);
	return obj;
}

static void
preferences_window_class_init (PreferencesWindowClass * klass,
                               gpointer klass_data)
{
	preferences_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PreferencesWindow_private_offset);
	G_OBJECT_CLASS (klass)->constructor = preferences_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = preferences_window_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/DejaDup/PreferencesWindow.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "location_description", FALSE, PreferencesWindow_private_offset + G_STRUCT_OFFSET (PreferencesWindowPrivate, location_description));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "labs_page", FALSE, PreferencesWindow_private_offset + G_STRUCT_OFFSET (PreferencesWindowPrivate, labs_page));
}

static void
preferences_window_instance_init (PreferencesWindow * self,
                                  gpointer klass)
{
	self->priv = preferences_window_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
preferences_window_finalize (GObject * obj)
{
	PreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_WINDOW, PreferencesWindow);
	g_debug ("PreferencesWindow.vala:58: Finalizing PreferencesWindow\n");
	G_OBJECT_CLASS (preferences_window_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
preferences_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesWindow), 0, (GInstanceInitFunc) preferences_window_instance_init, NULL };
	GType preferences_window_type_id;
	preferences_window_type_id = g_type_register_static (adw_preferences_window_get_type (), "PreferencesWindow", &g_define_type_info, 0);
	PreferencesWindow_private_offset = g_type_add_instance_private (preferences_window_type_id, sizeof (PreferencesWindowPrivate));
	return preferences_window_type_id;
}

GType
preferences_window_get_type (void)
{
	static gsize preferences_window_type_id__once = 0;
	if (g_once_init_enter (&preferences_window_type_id__once)) {
		GType preferences_window_type_id;
		preferences_window_type_id = preferences_window_get_type_once ();
		g_once_init_leave (&preferences_window_type_id__once, preferences_window_type_id);
	}
	return preferences_window_type_id__once;
}

