/* WidgetUtils.c generated by valac 0.56.1, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Canonical Ltd
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "deja.h"
#include <gio/gio.h>
#include <glib-object.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN void deja_dup_run_error_dialog (GtkWindow* parent,
                                const gchar* header,
                                const gchar* message);
static void _gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                              gint response_id,
                                              gpointer self);
VALA_EXTERN GtkBuilder* deja_dup_make_builder (const gchar* name);
VALA_EXTERN void deja_dup_set_margins (GtkWidget* w,
                           gint margin);
VALA_EXTERN gboolean deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings);
VALA_EXTERN void deja_dup_gui_initialize (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static void
_gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
	gtk_window_destroy ((GtkWindow*) self);
}

void
deja_dup_run_error_dialog (GtkWindow* parent,
                           const gchar* header,
                           const gchar* message)
{
	GtkMessageDialog* dlg = NULL;
	GtkMessageDialog* _tmp0_;
	g_return_if_fail (header != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", header);
	g_object_ref_sink (_tmp0_);
	dlg = _tmp0_;
	gtk_message_dialog_format_secondary_text (dlg, "%s", message);
	g_signal_connect_object ((GtkDialog*) dlg, "response", (GCallback) _gtk_window_destroy_gtk_dialog_response, (GtkWindow*) dlg, 0);
	gtk_window_present ((GtkWindow*) dlg);
	_g_object_unref0 (dlg);
}

GtkBuilder*
deja_dup_make_builder (const gchar* name)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkBuilder* _tmp4_;
	GtkBuilder* result;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = deja_dup_get_application_path ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("%s/%s.ui", _tmp1_, name);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	path = _tmp3_;
	_tmp4_ = gtk_builder_new_from_resource (path);
	result = _tmp4_;
	_g_free0 (path);
	return result;
}

void
deja_dup_set_margins (GtkWidget* w,
                      gint margin)
{
	g_return_if_fail (w != NULL);
	gtk_widget_set_margin_start (w, margin);
	gtk_widget_set_margin_end (w, margin);
	gtk_widget_set_margin_top (w, margin);
	gtk_widget_set_margin_bottom (w, margin);
}

gboolean
deja_dup_start_monitor_if_needed (DejaDupFilteredSettings* settings)
{
	gboolean result;
	g_return_val_if_fail (settings != NULL, FALSE);
	if (g_settings_get_boolean ((GSettings*) settings, DEJA_DUP_PERIODIC_KEY)) {
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint _tmp1__length1;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = g_new0 (gchar*, 0 + 1);
		_tmp1_ = _tmp0_;
		_tmp1__length1 = 0;
		_tmp2_ = deja_dup_get_monitor_exec ();
		_tmp3_ = _tmp2_;
		deja_dup_run_deja_dup (_tmp1_, (gint) 0, _tmp3_);
		_g_free0 (_tmp3_);
		_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL);
	}
	result = G_SOURCE_CONTINUE;
	return result;
}

void
deja_dup_gui_initialize (void)
{
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp0_;
	deja_dup_initialize ();
	_tmp0_ = deja_dup_get_settings (NULL);
	settings = _tmp0_;
	g_signal_connect (settings, "changed::" DEJA_DUP_PERIODIC_KEY, (GCallback) deja_dup_start_monitor_if_needed, NULL);
	deja_dup_start_monitor_if_needed (settings);
	g_object_ref ((GObject*) settings);
	_g_object_unref0 (settings);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

